mac80211: add multiple BSSID support
[openwrt/openwrt.git] / package / kernel / mac80211 / files / lib / netifd / wireless / mac80211.sh
1 #!/bin/sh
2 . /lib/netifd/netifd-wireless.sh
3 . /lib/netifd/hostapd.sh
4 . /lib/functions/system.sh
5
6 init_wireless_driver "$@"
7
8 MP_CONFIG_INT="mesh_retry_timeout mesh_confirm_timeout mesh_holding_timeout mesh_max_peer_links
9 mesh_max_retries mesh_ttl mesh_element_ttl mesh_hwmp_max_preq_retries
10 mesh_path_refresh_time mesh_min_discovery_timeout mesh_hwmp_active_path_timeout
11 mesh_hwmp_preq_min_interval mesh_hwmp_net_diameter_traversal_time mesh_hwmp_rootmode
12 mesh_hwmp_rann_interval mesh_gate_announcements mesh_sync_offset_max_neighor
13 mesh_rssi_threshold mesh_hwmp_active_path_to_root_timeout mesh_hwmp_root_interval
14 mesh_hwmp_confirmation_interval mesh_awake_window mesh_plink_timeout"
15 MP_CONFIG_BOOL="mesh_auto_open_plinks mesh_fwding"
16 MP_CONFIG_STRING="mesh_power_mode"
17
18 wdev_tool() {
19 ucode /usr/share/hostap/wdev.uc "$@"
20 }
21
22 drv_mac80211_init_device_config() {
23 hostapd_common_add_device_config
24
25 config_add_string path phy 'macaddr:macaddr'
26 config_add_string tx_burst
27 config_add_string distance
28 config_add_int beacon_int chanbw frag rts
29 config_add_int rxantenna txantenna txpower min_tx_power
30 config_add_int num_global_macaddr multiple_bssid
31 config_add_boolean noscan ht_coex acs_exclude_dfs background_radar
32 config_add_array ht_capab
33 config_add_array channels
34 config_add_array scan_list
35 config_add_boolean \
36 rxldpc \
37 short_gi_80 \
38 short_gi_160 \
39 tx_stbc_2by1 \
40 su_beamformer \
41 su_beamformee \
42 mu_beamformer \
43 mu_beamformee \
44 he_su_beamformer \
45 he_su_beamformee \
46 he_mu_beamformer \
47 vht_txop_ps \
48 htc_vht \
49 rx_antenna_pattern \
50 tx_antenna_pattern \
51 he_spr_sr_control \
52 he_spr_psr_enabled \
53 he_bss_color_enabled \
54 he_twt_required
55 config_add_int \
56 beamformer_antennas \
57 beamformee_antennas \
58 vht_max_a_mpdu_len_exp \
59 vht_max_mpdu \
60 vht_link_adapt \
61 vht160 \
62 rx_stbc \
63 tx_stbc \
64 he_bss_color \
65 he_spr_non_srg_obss_pd_max_offset
66 config_add_boolean \
67 ldpc \
68 greenfield \
69 short_gi_20 \
70 short_gi_40 \
71 max_amsdu \
72 dsss_cck_40
73 }
74
75 drv_mac80211_init_iface_config() {
76 hostapd_common_add_bss_config
77
78 config_add_string 'macaddr:macaddr' ifname
79
80 config_add_boolean wds powersave enable
81 config_add_string wds_bridge
82 config_add_int maxassoc
83 config_add_int max_listen_int
84 config_add_int dtim_period
85 config_add_int start_disabled
86
87 # mesh
88 config_add_string mesh_id
89 config_add_int $MP_CONFIG_INT
90 config_add_boolean $MP_CONFIG_BOOL
91 config_add_string $MP_CONFIG_STRING
92 }
93
94 mac80211_add_capabilities() {
95 local __var="$1"; shift
96 local __mask="$1"; shift
97 local __out= oifs
98
99 oifs="$IFS"
100 IFS=:
101 for capab in "$@"; do
102 set -- $capab
103
104 [ "$(($4))" -gt 0 ] || continue
105 [ "$(($__mask & $2))" -eq "$((${3:-$2}))" ] || continue
106 __out="$__out[$1]"
107 done
108 IFS="$oifs"
109
110 export -n -- "$__var=$__out"
111 }
112
113 mac80211_add_he_capabilities() {
114 local __out= oifs
115
116 oifs="$IFS"
117 IFS=:
118 for capab in "$@"; do
119 set -- $capab
120 [ "$(($4))" -gt 0 ] || continue
121 [ "$(((0x$2) & $3))" -gt 0 ] || {
122 eval "$1=0"
123 continue
124 }
125 append base_cfg "$1=1" "$N"
126 done
127 IFS="$oifs"
128 }
129
130 mac80211_hostapd_setup_base() {
131 local phy="$1"
132
133 json_select config
134
135 [ "$auto_channel" -gt 0 ] && channel=acs_survey
136
137 [ "$auto_channel" -gt 0 ] && json_get_vars acs_exclude_dfs
138 [ -n "$acs_exclude_dfs" ] && [ "$acs_exclude_dfs" -gt 0 ] &&
139 append base_cfg "acs_exclude_dfs=1" "$N"
140
141 json_get_vars noscan ht_coex min_tx_power:0 tx_burst
142 json_get_values ht_capab_list ht_capab
143 json_get_values channel_list channels
144
145 [ "$auto_channel" = 0 ] && [ -z "$channel_list" ] && \
146 channel_list="$channel"
147
148 [ "$min_tx_power" -gt 0 ] && append base_cfg "min_tx_power=$min_tx_power"
149
150 set_default noscan 0
151
152 [ "$noscan" -gt 0 ] && hostapd_noscan=1
153 [ "$tx_burst" = 0 ] && tx_burst=
154
155 chan_ofs=0
156 [ "$band" = "6g" ] && chan_ofs=1
157
158 ieee80211n=1
159 ht_capab=
160 case "$htmode" in
161 VHT20|HT20|HE20) ;;
162 HT40*|VHT40|VHT80|VHT160|HE40|HE80|HE160)
163 case "$hwmode" in
164 a)
165 case "$(( (($channel / 4) + $chan_ofs) % 2 ))" in
166 1) ht_capab="[HT40+]";;
167 0) ht_capab="[HT40-]";;
168 esac
169 ;;
170 *)
171 case "$htmode" in
172 HT40+) ht_capab="[HT40+]";;
173 HT40-) ht_capab="[HT40-]";;
174 *)
175 if [ "$channel" -lt 7 ]; then
176 ht_capab="[HT40+]"
177 else
178 ht_capab="[HT40-]"
179 fi
180 ;;
181 esac
182 ;;
183 esac
184 [ "$auto_channel" -gt 0 ] && ht_capab="[HT40+]"
185 ;;
186 *) ieee80211n= ;;
187 esac
188
189 [ -n "$ieee80211n" ] && {
190 append base_cfg "ieee80211n=1" "$N"
191
192 set_default ht_coex 0
193 append base_cfg "ht_coex=$ht_coex" "$N"
194
195 json_get_vars \
196 ldpc:1 \
197 greenfield:0 \
198 short_gi_20:1 \
199 short_gi_40:1 \
200 tx_stbc:1 \
201 rx_stbc:3 \
202 max_amsdu:1 \
203 dsss_cck_40:1
204
205 ht_cap_mask=0
206 for cap in $(iw phy "$phy" info | grep 'Capabilities:' | cut -d: -f2); do
207 ht_cap_mask="$(($ht_cap_mask | $cap))"
208 done
209
210 cap_rx_stbc=$((($ht_cap_mask >> 8) & 3))
211 [ "$rx_stbc" -lt "$cap_rx_stbc" ] && cap_rx_stbc="$rx_stbc"
212 ht_cap_mask="$(( ($ht_cap_mask & ~(0x300)) | ($cap_rx_stbc << 8) ))"
213
214 mac80211_add_capabilities ht_capab_flags $ht_cap_mask \
215 LDPC:0x1::$ldpc \
216 GF:0x10::$greenfield \
217 SHORT-GI-20:0x20::$short_gi_20 \
218 SHORT-GI-40:0x40::$short_gi_40 \
219 TX-STBC:0x80::$tx_stbc \
220 RX-STBC1:0x300:0x100:1 \
221 RX-STBC12:0x300:0x200:1 \
222 RX-STBC123:0x300:0x300:1 \
223 MAX-AMSDU-7935:0x800::$max_amsdu \
224 DSSS_CCK-40:0x1000::$dsss_cck_40
225
226 ht_capab="$ht_capab$ht_capab_flags"
227 [ -n "$ht_capab" ] && append base_cfg "ht_capab=$ht_capab" "$N"
228 }
229
230 # 802.11ac
231 enable_ac=0
232 vht_oper_chwidth=0
233 vht_center_seg0=
234
235 idx="$channel"
236 case "$htmode" in
237 VHT20|HE20) enable_ac=1;;
238 VHT40|HE40)
239 case "$(( (($channel / 4) + $chan_ofs) % 2 ))" in
240 1) idx=$(($channel + 2));;
241 0) idx=$(($channel - 2));;
242 esac
243 enable_ac=1
244 vht_center_seg0=$idx
245 ;;
246 VHT80|HE80)
247 case "$(( (($channel / 4) + $chan_ofs) % 4 ))" in
248 1) idx=$(($channel + 6));;
249 2) idx=$(($channel + 2));;
250 3) idx=$(($channel - 2));;
251 0) idx=$(($channel - 6));;
252 esac
253 enable_ac=1
254 vht_oper_chwidth=1
255 vht_center_seg0=$idx
256 ;;
257 VHT160|HE160)
258 if [ "$band" = "6g" ]; then
259 case "$channel" in
260 1|5|9|13|17|21|25|29) idx=15;;
261 33|37|41|45|49|53|57|61) idx=47;;
262 65|69|73|77|81|85|89|93) idx=79;;
263 97|101|105|109|113|117|121|125) idx=111;;
264 129|133|137|141|145|149|153|157) idx=143;;
265 161|165|169|173|177|181|185|189) idx=175;;
266 193|197|201|205|209|213|217|221) idx=207;;
267 esac
268 else
269 case "$channel" in
270 36|40|44|48|52|56|60|64) idx=50;;
271 100|104|108|112|116|120|124|128) idx=114;;
272 esac
273 fi
274 enable_ac=1
275 vht_oper_chwidth=2
276 vht_center_seg0=$idx
277 ;;
278 esac
279 [ "$band" = "5g" ] && {
280 json_get_vars background_radar:0
281
282 [ "$background_radar" -eq 1 ] && append base_cfg "enable_background_radar=1" "$N"
283 }
284 [ "$band" = "6g" ] && {
285 op_class=
286 case "$htmode" in
287 HE20) op_class=131;;
288 HE*) op_class=$((132 + $vht_oper_chwidth))
289 esac
290 [ -n "$op_class" ] && append base_cfg "op_class=$op_class" "$N"
291 }
292 [ "$hwmode" = "a" ] || enable_ac=0
293
294 if [ "$enable_ac" != "0" ]; then
295 json_get_vars \
296 rxldpc:1 \
297 short_gi_80:1 \
298 short_gi_160:1 \
299 tx_stbc_2by1:1 \
300 su_beamformer:1 \
301 su_beamformee:1 \
302 mu_beamformer:1 \
303 mu_beamformee:1 \
304 vht_txop_ps:1 \
305 htc_vht:1 \
306 beamformee_antennas:4 \
307 beamformer_antennas:4 \
308 rx_antenna_pattern:1 \
309 tx_antenna_pattern:1 \
310 vht_max_a_mpdu_len_exp:7 \
311 vht_max_mpdu:11454 \
312 rx_stbc:4 \
313 vht_link_adapt:3 \
314 vht160:2
315
316 set_default tx_burst 2.0
317 append base_cfg "ieee80211ac=1" "$N"
318 vht_cap=0
319 for cap in $(iw phy "$phy" info | awk -F "[()]" '/VHT Capabilities/ { print $2 }'); do
320 vht_cap="$(($vht_cap | $cap))"
321 done
322
323 append base_cfg "vht_oper_chwidth=$vht_oper_chwidth" "$N"
324 append base_cfg "vht_oper_centr_freq_seg0_idx=$vht_center_seg0" "$N"
325
326 cap_rx_stbc=$((($vht_cap >> 8) & 7))
327 [ "$rx_stbc" -lt "$cap_rx_stbc" ] && cap_rx_stbc="$rx_stbc"
328 vht_cap="$(( ($vht_cap & ~(0x700)) | ($cap_rx_stbc << 8) ))"
329
330 mac80211_add_capabilities vht_capab $vht_cap \
331 RXLDPC:0x10::$rxldpc \
332 SHORT-GI-80:0x20::$short_gi_80 \
333 SHORT-GI-160:0x40::$short_gi_160 \
334 TX-STBC-2BY1:0x80::$tx_stbc_2by1 \
335 SU-BEAMFORMER:0x800::$su_beamformer \
336 SU-BEAMFORMEE:0x1000::$su_beamformee \
337 MU-BEAMFORMER:0x80000::$mu_beamformer \
338 MU-BEAMFORMEE:0x100000::$mu_beamformee \
339 VHT-TXOP-PS:0x200000::$vht_txop_ps \
340 HTC-VHT:0x400000::$htc_vht \
341 RX-ANTENNA-PATTERN:0x10000000::$rx_antenna_pattern \
342 TX-ANTENNA-PATTERN:0x20000000::$tx_antenna_pattern \
343 RX-STBC-1:0x700:0x100:1 \
344 RX-STBC-12:0x700:0x200:1 \
345 RX-STBC-123:0x700:0x300:1 \
346 RX-STBC-1234:0x700:0x400:1 \
347
348 [ "$(($vht_cap & 0x800))" -gt 0 -a "$su_beamformer" -gt 0 ] && {
349 cap_ant="$(( ( ($vht_cap >> 16) & 3 ) + 1 ))"
350 [ "$cap_ant" -gt "$beamformer_antennas" ] && cap_ant="$beamformer_antennas"
351 [ "$cap_ant" -gt 1 ] && vht_capab="$vht_capab[SOUNDING-DIMENSION-$cap_ant]"
352 }
353
354 [ "$(($vht_cap & 0x1000))" -gt 0 -a "$su_beamformee" -gt 0 ] && {
355 cap_ant="$(( ( ($vht_cap >> 13) & 3 ) + 1 ))"
356 [ "$cap_ant" -gt "$beamformee_antennas" ] && cap_ant="$beamformee_antennas"
357 [ "$cap_ant" -gt 1 ] && vht_capab="$vht_capab[BF-ANTENNA-$cap_ant]"
358 }
359
360 # supported Channel widths
361 vht160_hw=0
362 [ "$(($vht_cap & 12))" -eq 4 -a 1 -le "$vht160" ] && \
363 vht160_hw=1
364 [ "$(($vht_cap & 12))" -eq 8 -a 2 -le "$vht160" ] && \
365 vht160_hw=2
366 [ "$vht160_hw" = 1 ] && vht_capab="$vht_capab[VHT160]"
367 [ "$vht160_hw" = 2 ] && vht_capab="$vht_capab[VHT160-80PLUS80]"
368
369 # maximum MPDU length
370 vht_max_mpdu_hw=3895
371 [ "$(($vht_cap & 3))" -ge 1 -a 7991 -le "$vht_max_mpdu" ] && \
372 vht_max_mpdu_hw=7991
373 [ "$(($vht_cap & 3))" -ge 2 -a 11454 -le "$vht_max_mpdu" ] && \
374 vht_max_mpdu_hw=11454
375 [ "$vht_max_mpdu_hw" != 3895 ] && \
376 vht_capab="$vht_capab[MAX-MPDU-$vht_max_mpdu_hw]"
377
378 # maximum A-MPDU length exponent
379 vht_max_a_mpdu_len_exp_hw=0
380 [ "$(($vht_cap & 58720256))" -ge 8388608 -a 1 -le "$vht_max_a_mpdu_len_exp" ] && \
381 vht_max_a_mpdu_len_exp_hw=1
382 [ "$(($vht_cap & 58720256))" -ge 16777216 -a 2 -le "$vht_max_a_mpdu_len_exp" ] && \
383 vht_max_a_mpdu_len_exp_hw=2
384 [ "$(($vht_cap & 58720256))" -ge 25165824 -a 3 -le "$vht_max_a_mpdu_len_exp" ] && \
385 vht_max_a_mpdu_len_exp_hw=3
386 [ "$(($vht_cap & 58720256))" -ge 33554432 -a 4 -le "$vht_max_a_mpdu_len_exp" ] && \
387 vht_max_a_mpdu_len_exp_hw=4
388 [ "$(($vht_cap & 58720256))" -ge 41943040 -a 5 -le "$vht_max_a_mpdu_len_exp" ] && \
389 vht_max_a_mpdu_len_exp_hw=5
390 [ "$(($vht_cap & 58720256))" -ge 50331648 -a 6 -le "$vht_max_a_mpdu_len_exp" ] && \
391 vht_max_a_mpdu_len_exp_hw=6
392 [ "$(($vht_cap & 58720256))" -ge 58720256 -a 7 -le "$vht_max_a_mpdu_len_exp" ] && \
393 vht_max_a_mpdu_len_exp_hw=7
394 vht_capab="$vht_capab[MAX-A-MPDU-LEN-EXP$vht_max_a_mpdu_len_exp_hw]"
395
396 # whether or not the STA supports link adaptation using VHT variant
397 vht_link_adapt_hw=0
398 [ "$(($vht_cap & 201326592))" -ge 134217728 -a 2 -le "$vht_link_adapt" ] && \
399 vht_link_adapt_hw=2
400 [ "$(($vht_cap & 201326592))" -ge 201326592 -a 3 -le "$vht_link_adapt" ] && \
401 vht_link_adapt_hw=3
402 [ "$vht_link_adapt_hw" != 0 ] && \
403 vht_capab="$vht_capab[VHT-LINK-ADAPT-$vht_link_adapt_hw]"
404
405 [ -n "$vht_capab" ] && append base_cfg "vht_capab=$vht_capab" "$N"
406 fi
407
408 # 802.11ax
409 enable_ax=0
410 case "$htmode" in
411 HE*) enable_ax=1 ;;
412 esac
413
414 if [ "$enable_ax" != "0" ]; then
415 json_get_vars \
416 he_su_beamformer:1 \
417 he_su_beamformee:1 \
418 he_mu_beamformer:1 \
419 he_twt_required:0 \
420 he_spr_sr_control:3 \
421 he_spr_psr_enabled:0 \
422 he_spr_non_srg_obss_pd_max_offset:0 \
423 he_bss_color:128 \
424 he_bss_color_enabled:1
425
426 he_phy_cap=$(iw phy "$phy" info | sed -n '/HE Iftypes: AP/,$p' | awk -F "[()]" '/HE PHY Capabilities/ { print $2 }' | head -1)
427 he_phy_cap=${he_phy_cap:2}
428 he_mac_cap=$(iw phy "$phy" info | sed -n '/HE Iftypes: AP/,$p' | awk -F "[()]" '/HE MAC Capabilities/ { print $2 }' | head -1)
429 he_mac_cap=${he_mac_cap:2}
430
431 append base_cfg "ieee80211ax=1" "$N"
432 [ "$hwmode" = "a" ] && {
433 append base_cfg "he_oper_chwidth=$vht_oper_chwidth" "$N"
434 append base_cfg "he_oper_centr_freq_seg0_idx=$vht_center_seg0" "$N"
435 }
436
437 mac80211_add_he_capabilities \
438 he_su_beamformer:${he_phy_cap:6:2}:0x80:$he_su_beamformer \
439 he_su_beamformee:${he_phy_cap:8:2}:0x1:$he_su_beamformee \
440 he_mu_beamformer:${he_phy_cap:8:2}:0x2:$he_mu_beamformer \
441 he_spr_psr_enabled:${he_phy_cap:14:2}:0x1:$he_spr_psr_enabled \
442 he_twt_required:${he_mac_cap:0:2}:0x6:$he_twt_required
443
444 if [ "$he_bss_color_enabled" -gt 0 ]; then
445 append base_cfg "he_bss_color=$he_bss_color" "$N"
446 [ "$he_spr_non_srg_obss_pd_max_offset" -gt 0 ] && { \
447 append base_cfg "he_spr_non_srg_obss_pd_max_offset=$he_spr_non_srg_obss_pd_max_offset" "$N"
448 he_spr_sr_control=$((he_spr_sr_control | (1 << 2)))
449 }
450 [ "$he_spr_psr_enabled" -gt 0 ] || he_spr_sr_control=$((he_spr_sr_control | (1 << 0)))
451 append base_cfg "he_spr_sr_control=$he_spr_sr_control" "$N"
452 else
453 append base_cfg "he_bss_color_disabled=1" "$N"
454 fi
455
456
457 append base_cfg "he_default_pe_duration=4" "$N"
458 append base_cfg "he_rts_threshold=1023" "$N"
459 append base_cfg "he_mu_edca_qos_info_param_count=0" "$N"
460 append base_cfg "he_mu_edca_qos_info_q_ack=0" "$N"
461 append base_cfg "he_mu_edca_qos_info_queue_request=0" "$N"
462 append base_cfg "he_mu_edca_qos_info_txop_request=0" "$N"
463 append base_cfg "he_mu_edca_ac_be_aifsn=8" "$N"
464 append base_cfg "he_mu_edca_ac_be_aci=0" "$N"
465 append base_cfg "he_mu_edca_ac_be_ecwmin=9" "$N"
466 append base_cfg "he_mu_edca_ac_be_ecwmax=10" "$N"
467 append base_cfg "he_mu_edca_ac_be_timer=255" "$N"
468 append base_cfg "he_mu_edca_ac_bk_aifsn=15" "$N"
469 append base_cfg "he_mu_edca_ac_bk_aci=1" "$N"
470 append base_cfg "he_mu_edca_ac_bk_ecwmin=9" "$N"
471 append base_cfg "he_mu_edca_ac_bk_ecwmax=10" "$N"
472 append base_cfg "he_mu_edca_ac_bk_timer=255" "$N"
473 append base_cfg "he_mu_edca_ac_vi_ecwmin=5" "$N"
474 append base_cfg "he_mu_edca_ac_vi_ecwmax=7" "$N"
475 append base_cfg "he_mu_edca_ac_vi_aifsn=5" "$N"
476 append base_cfg "he_mu_edca_ac_vi_aci=2" "$N"
477 append base_cfg "he_mu_edca_ac_vi_timer=255" "$N"
478 append base_cfg "he_mu_edca_ac_vo_aifsn=5" "$N"
479 append base_cfg "he_mu_edca_ac_vo_aci=3" "$N"
480 append base_cfg "he_mu_edca_ac_vo_ecwmin=5" "$N"
481 append base_cfg "he_mu_edca_ac_vo_ecwmax=7" "$N"
482 append base_cfg "he_mu_edca_ac_vo_timer=255" "$N"
483 fi
484
485 hostapd_prepare_device_config "$hostapd_conf_file" nl80211
486 cat >> "$hostapd_conf_file" <<EOF
487 ${channel:+channel=$channel}
488 ${channel_list:+chanlist=$channel_list}
489 ${hostapd_noscan:+noscan=1}
490 ${tx_burst:+tx_queue_data2_burst=$tx_burst}
491 mbssid=$multiple_bssid
492 $base_cfg
493
494 EOF
495 json_select ..
496 }
497
498 mac80211_hostapd_setup_bss() {
499 local phy="$1"
500 local ifname="$2"
501 local macaddr="$3"
502 local type="$4"
503
504 hostapd_cfg=
505 append hostapd_cfg "$type=$ifname" "$N"
506
507 hostapd_set_bss_options hostapd_cfg "$phy" "$vif" || return 1
508 json_get_vars wds wds_bridge dtim_period max_listen_int start_disabled
509
510 set_default wds 0
511 set_default start_disabled 0
512
513 [ "$wds" -gt 0 ] && {
514 append hostapd_cfg "wds_sta=1" "$N"
515 [ -n "$wds_bridge" ] && append hostapd_cfg "wds_bridge=$wds_bridge" "$N"
516 }
517 [ "$staidx" -gt 0 -o "$start_disabled" -eq 1 ] && append hostapd_cfg "start_disabled=1" "$N"
518
519 cat >> /var/run/hostapd-$phy.conf <<EOF
520 $hostapd_cfg
521 bssid=$macaddr
522 ${dtim_period:+dtim_period=$dtim_period}
523 ${max_listen_int:+max_listen_interval=$max_listen_int}
524 EOF
525 }
526
527 mac80211_get_addr() {
528 local phy="$1"
529 local idx="$(($2 + 1))"
530
531 head -n $idx /sys/class/ieee80211/${phy}/addresses | tail -n1
532 }
533
534 mac80211_generate_mac() {
535 local phy="$1"
536 local id="${macidx:-0}"
537
538 wdev_tool "$phy" get_macaddr id=$id num_global=$num_global_macaddr mbssid=$multiple_bssid
539 }
540
541 get_board_phy_name() (
542 local path="$1"
543 local fallback_phy=""
544
545 __check_phy() {
546 local val="$1"
547 local key="$2"
548 local ref_path="$3"
549
550 json_select "$key"
551 json_get_values path
552 json_select ..
553
554 [ "${ref_path%+*}" = "$path" ] && fallback_phy=$key
555 [ "$ref_path" = "$path" ] || return 0
556
557 echo "$key"
558 exit
559 }
560
561 json_load_file /etc/board.json
562 json_for_each_item __check_phy wlan "$path"
563 [ -n "$fallback_phy" ] && echo "${fallback_phy}.${path##*+}"
564 )
565
566 rename_board_phy_by_path() {
567 local path="$1"
568
569 local new_phy="$(get_board_phy_name "$path")"
570 [ -z "$new_phy" -o "$new_phy" = "$phy" ] && return
571
572 iw "$phy" set name "$new_phy" && phy="$new_phy"
573 }
574
575 rename_board_phy_by_name() (
576 local phy="$1"
577 local suffix="${phy##*.}"
578 [ "$suffix" = "$phy" ] && suffix=
579
580 json_load_file /etc/board.json
581 json_select wlan
582 json_select "${phy%.*}" || return 0
583 json_get_values path
584
585 prev_phy="$(iwinfo nl80211 phyname "path=$path${suffix:++$suffix}")"
586 [ -n "$prev_phy" ] || return 0
587
588 [ "$prev_phy" = "$phy" ] && return 0
589
590 iw "$prev_phy" set name "$phy"
591 )
592
593 find_phy() {
594 [ -n "$phy" ] && {
595 rename_board_phy_by_name "$phy"
596 [ -d /sys/class/ieee80211/$phy ] && return 0
597 }
598 [ -n "$path" ] && {
599 phy="$(iwinfo nl80211 phyname "path=$path")"
600 [ -n "$phy" ] && {
601 rename_board_phy_by_path "$path"
602 return 0
603 }
604 }
605 [ -n "$macaddr" ] && {
606 for phy in $(ls /sys/class/ieee80211 2>/dev/null); do
607 grep -i -q "$macaddr" "/sys/class/ieee80211/${phy}/macaddress" && {
608 path="$(iwinfo nl80211 path "$phy")"
609 rename_board_phy_by_path "$path"
610 return 0
611 }
612 done
613 }
614 return 1
615 }
616
617 mac80211_check_ap() {
618 has_ap=1
619 }
620
621 mac80211_set_ifname() {
622 local phy="$1"
623 local prefix="$2"
624 eval "ifname=\"$phy-$prefix\${idx_$prefix:-0}\"; idx_$prefix=\$((\${idx_$prefix:-0 } + 1))"
625 }
626
627 mac80211_prepare_vif() {
628 json_select config
629
630 json_get_vars ifname mode ssid wds powersave macaddr enable wpa_psk_file vlan_file
631
632 [ -n "$ifname" ] || {
633 local prefix;
634
635 case "$mode" in
636 ap|sta|mesh) prefix=$mode;;
637 adhoc) prefix=ibss;;
638 monitor) prefix=mon;;
639 esac
640
641 mac80211_set_ifname "$phy" "$prefix"
642 }
643
644 append active_ifnames "$ifname"
645 set_default wds 0
646 set_default powersave 0
647 json_add_string _ifname "$ifname"
648
649 if [ -z "$macaddr" ]; then
650 macaddr="$(mac80211_generate_mac $phy)"
651 macidx="$(($macidx + 1))"
652 elif [ "$macaddr" = 'random' ]; then
653 macaddr="$(macaddr_random)"
654 fi
655 json_add_string _macaddr "$macaddr"
656 json_select ..
657
658
659 [ "$mode" == "ap" ] && {
660 [ -z "$wpa_psk_file" ] && hostapd_set_psk "$ifname"
661 [ -z "$vlan_file" ] && hostapd_set_vlan "$ifname"
662 }
663
664 json_select config
665
666 # It is far easier to delete and create the desired interface
667 case "$mode" in
668 ap)
669 # Hostapd will handle recreating the interface and
670 # subsequent virtual APs belonging to the same PHY
671 if [ -n "$hostapd_ctrl" ]; then
672 type=bss
673 else
674 type=interface
675 fi
676
677 mac80211_hostapd_setup_bss "$phy" "$ifname" "$macaddr" "$type" || return
678
679 [ -n "$hostapd_ctrl" ] || {
680 ap_ifname="${ifname}"
681 hostapd_ctrl="${hostapd_ctrl:-/var/run/hostapd/$ifname}"
682 }
683 ;;
684 esac
685
686 json_select ..
687 }
688
689 mac80211_prepare_iw_htmode() {
690 case "$htmode" in
691 VHT20|HT20|HE20) iw_htmode=HT20;;
692 HT40*|VHT40|VHT160|HE40)
693 case "$band" in
694 2g)
695 case "$htmode" in
696 HT40+) iw_htmode="HT40+";;
697 HT40-) iw_htmode="HT40-";;
698 *)
699 if [ "$channel" -lt 7 ]; then
700 iw_htmode="HT40+"
701 else
702 iw_htmode="HT40-"
703 fi
704 ;;
705 esac
706 ;;
707 *)
708 case "$(( ($channel / 4) % 2 ))" in
709 1) iw_htmode="HT40+" ;;
710 0) iw_htmode="HT40-";;
711 esac
712 ;;
713 esac
714 [ "$auto_channel" -gt 0 ] && iw_htmode="HT40+"
715 ;;
716 VHT80|HE80)
717 iw_htmode="80MHZ"
718 ;;
719 NONE|NOHT)
720 iw_htmode="NOHT"
721 ;;
722 *) iw_htmode="" ;;
723 esac
724 }
725
726 mac80211_add_mesh_params() {
727 for var in $MP_CONFIG_INT $MP_CONFIG_BOOL $MP_CONFIG_STRING; do
728 eval "mp_val=\"\$$var\""
729 [ -n "$mp_val" ] && json_add_string "$var" "$mp_val"
730 done
731 }
732
733 mac80211_setup_adhoc() {
734 local enable=$1
735 json_get_vars bssid ssid key mcast_rate
736
737 NEWUMLIST="${NEWUMLIST}$ifname "
738
739 [ "$enable" = 0 ] && {
740 ip link set dev "$ifname" down
741 return 0
742 }
743
744 keyspec=
745 [ "$auth_type" = "wep" ] && {
746 set_default key 1
747 case "$key" in
748 [1234])
749 local idx
750 for idx in 1 2 3 4; do
751 json_get_var ikey "key$idx"
752
753 [ -n "$ikey" ] && {
754 ikey="$(($idx - 1)):$(prepare_key_wep "$ikey")"
755 [ $idx -eq $key ] && ikey="d:$ikey"
756 append keyspec "$ikey"
757 }
758 done
759 ;;
760 *)
761 append keyspec "d:0:$(prepare_key_wep "$key")"
762 ;;
763 esac
764 }
765
766 brstr=
767 for br in $basic_rate_list; do
768 wpa_supplicant_add_rate brstr "$br"
769 done
770
771 mcval=
772 [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
773
774 local prev
775 json_set_namespace wdev_uc prev
776
777 json_add_object "$ifname"
778 json_add_string mode adhoc
779 json_add_string macaddr "$macaddr"
780 json_add_string ssid "$ssid"
781 json_add_string freq "$freq"
782 json_add_string htmode "$iw_htmode"
783 [ -n "$bssid" ] && json_add_string bssid "$bssid"
784 json_add_int beacon-interval "$beacon_int"
785 [ -n "$brstr" ] && json_add_string basic-rates "$brstr"
786 [ -n "$mcval" ] && json_add_string mcast-rate "$mcval"
787 [ -n "$keyspec" ] && json_add_string keys "$keyspec"
788 json_close_object
789
790 json_set_namespace "$prev"
791 }
792
793 mac80211_setup_mesh() {
794 json_get_vars ssid mesh_id mcast_rate
795
796 mcval=
797 [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
798 [ -n "$mesh_id" ] && ssid="$mesh_id"
799
800 local prev
801 json_set_namespace wdev_uc prev
802
803 json_add_object "$ifname"
804 json_add_string mode mesh
805 json_add_string macaddr "$macaddr"
806 json_add_string ssid "$ssid"
807 json_add_string freq "$freq"
808 json_add_string htmode "$iw_htmode"
809 [ -n "$mcval" ] && json_add_string mcast-rate "$mcval"
810 json_add_int beacon-interval "$beacon_int"
811 mac80211_add_mesh_params
812
813 json_close_object
814
815 json_set_namespace "$prev"
816 }
817
818 mac80211_setup_monitor() {
819 local prev
820 json_set_namespace wdev_uc prev
821
822 json_add_object "$ifname"
823 json_add_string mode monitor
824 [ -n "$freq" ] && json_add_string freq "$freq"
825 json_add_string htmode "$iw_htmode"
826 json_close_object
827
828 json_set_namespace "$prev"
829 }
830
831 mac80211_set_vif_txpower() {
832 local name="$1"
833
834 json_select config
835 json_get_var ifname _ifname
836 json_get_vars vif_txpower
837 json_select ..
838
839 [ -z "$vif_txpower" ] || iw dev "$ifname" set txpower fixed "${vif_txpower%%.*}00"
840 }
841
842 wpa_supplicant_init_config() {
843 json_set_namespace wpa_supp prev
844
845 json_init
846 json_add_array config
847
848 json_set_namespace "$prev"
849 }
850
851 wpa_supplicant_add_interface() {
852 local ifname="$1"
853 local mode="$2"
854 local prev
855
856 _wpa_supplicant_common "$ifname"
857
858 json_set_namespace wpa_supp prev
859
860 json_add_object
861 json_add_string ctrl "$_rpath"
862 json_add_string iface "$ifname"
863 json_add_string mode "$mode"
864 json_add_string config "$_config"
865 json_add_string macaddr "$macaddr"
866 [ -n "$network_bridge" ] && json_add_string bridge "$network_bridge"
867 [ -n "$wds" ] && json_add_boolean 4addr "$wds"
868 json_add_boolean powersave "$powersave"
869 [ "$mode" = "mesh" ] && mac80211_add_mesh_params
870 json_close_object
871
872 json_set_namespace "$prev"
873
874 wpa_supp_init=1
875 }
876
877 wpa_supplicant_set_config() {
878 local phy="$1"
879 local prev
880
881 json_set_namespace wpa_supp prev
882 json_close_array
883 json_add_string phy "$phy"
884 json_add_boolean defer 1
885 local data="$(json_dump)"
886
887 json_cleanup
888 json_set_namespace "$prev"
889
890 ubus -S -t 0 wait_for wpa_supplicant || {
891 [ -n "$wpa_supp_init" ] || return 0
892
893 ubus wait_for wpa_supplicant
894 }
895
896 local supplicant_res="$(ubus call wpa_supplicant config_set "$data")"
897 ret="$?"
898 [ "$ret" != 0 -o -z "$supplicant_res" ] && wireless_setup_vif_failed WPA_SUPPLICANT_FAILED
899
900 wireless_add_process "$(jsonfilter -s "$supplicant_res" -l 1 -e @.pid)" "/usr/sbin/wpa_supplicant" 1 1
901
902 }
903
904 hostapd_set_config() {
905 [ -n "$hostapd_ctrl" ] || {
906 ubus call hostapd config_set '{ "phy": "'"$phy"'", "config": "", "prev_config": "'"${hostapd_conf_file}.prev"'" }' > /dev/null
907 return 0;
908 }
909
910 ubus wait_for hostapd
911 local hostapd_res="$(ubus call hostapd config_set "{ \"phy\": \"$phy\", \"config\":\"${hostapd_conf_file}\", \"prev_config\": \"${hostapd_conf_file}.prev\"}")"
912 ret="$?"
913 [ "$ret" != 0 -o -z "$hostapd_res" ] && {
914 wireless_setup_failed HOSTAPD_START_FAILED
915 return
916 }
917 wireless_add_process "$(jsonfilter -s "$hostapd_res" -l 1 -e @.pid)" "/usr/sbin/hostapd" 1 1
918 }
919
920
921 wpa_supplicant_start() {
922 local phy="$1"
923
924 [ -n "$wpa_supp_init" ] || return 0
925
926 ubus call wpa_supplicant config_set '{ "phy": "'"$phy"'" }' > /dev/null
927 }
928
929 mac80211_setup_supplicant() {
930 local enable=$1
931 local add_sp=0
932
933 wpa_supplicant_prepare_interface "$ifname" nl80211 || return 1
934
935 if [ "$mode" = "sta" ]; then
936 wpa_supplicant_add_network "$ifname"
937 else
938 wpa_supplicant_add_network "$ifname" "$freq" "$htmode" "$noscan"
939 fi
940
941 wpa_supplicant_add_interface "$ifname" "$mode"
942
943 return 0
944 }
945
946 mac80211_setup_vif() {
947 local name="$1"
948 local failed
949
950 json_select config
951 json_get_var ifname _ifname
952 json_get_var macaddr _macaddr
953 json_get_vars mode wds powersave
954
955 set_default powersave 0
956 set_default wds 0
957
958 case "$mode" in
959 mesh)
960 json_get_vars $MP_CONFIG_INT $MP_CONFIG_BOOL $MP_CONFIG_STRING
961 wireless_vif_parse_encryption
962 [ -z "$htmode" ] && htmode="NOHT";
963 if wpa_supplicant -vmesh; then
964 mac80211_setup_supplicant || failed=1
965 else
966 mac80211_setup_mesh
967 fi
968 ;;
969 adhoc)
970 wireless_vif_parse_encryption
971 if [ "$wpa" -gt 0 -o "$auto_channel" -gt 0 ]; then
972 mac80211_setup_supplicant || failed=1
973 else
974 mac80211_setup_adhoc
975 fi
976 ;;
977 sta)
978 mac80211_setup_supplicant || failed=1
979 ;;
980 monitor)
981 mac80211_setup_monitor
982 ;;
983 esac
984
985 json_select ..
986 [ -n "$failed" ] || wireless_add_vif "$name" "$ifname"
987 }
988
989 get_freq() {
990 local phy="$1"
991 local channel="$2"
992 local band="$3"
993
994 case "$band" in
995 2g) band="1:";;
996 5g) band="2:";;
997 60g) band="3:";;
998 6g) band="4:";;
999 esac
1000
1001 iw "$phy" info | awk -v band="$band" -v channel="[$channel]" '
1002
1003 $1 ~ /Band/ {
1004 band_match = band == $2
1005 }
1006
1007 band_match && $3 == "MHz" && $4 == channel {
1008 print $2
1009 exit
1010 }
1011 '
1012 }
1013
1014 chan_is_dfs() {
1015 local phy="$1"
1016 local chan="$2"
1017 iw "$phy" info | grep -E -m1 "(\* ${chan:-....} MHz${chan:+|\\[$chan\\]})" | grep -q "MHz.*radar detection"
1018 return $!
1019 }
1020
1021 mac80211_set_noscan() {
1022 hostapd_noscan=1
1023 }
1024
1025 drv_mac80211_cleanup() {
1026 hostapd_common_cleanup
1027 }
1028
1029 mac80211_reset_config() {
1030 local phy="$1"
1031
1032 hostapd_conf_file="/var/run/hostapd-$phy.conf"
1033 ubus call hostapd config_set '{ "phy": "'"$phy"'", "config": "", "prev_config": "'"$hostapd_conf_file"'" }' > /dev/null
1034 ubus call wpa_supplicant config_set '{ "phy": "'"$phy"'", "config": [] }' > /dev/null
1035 wdev_tool "$phy" set_config '{}'
1036 }
1037
1038 drv_mac80211_setup() {
1039 json_select config
1040 json_get_vars \
1041 phy macaddr path \
1042 country chanbw distance \
1043 txpower \
1044 rxantenna txantenna \
1045 frag rts beacon_int:100 htmode \
1046 num_global_macaddr:1 multiple_bssid:0
1047 json_get_values basic_rate_list basic_rate
1048 json_get_values scan_list scan_list
1049 json_select ..
1050
1051 json_select data && {
1052 json_get_var prev_rxantenna rxantenna
1053 json_get_var prev_txantenna txantenna
1054 json_select ..
1055 }
1056
1057 find_phy || {
1058 echo "Could not find PHY for device '$1'"
1059 wireless_set_retry 0
1060 return 1
1061 }
1062
1063 local wdev
1064 local cwdev
1065 local found
1066
1067 # convert channel to frequency
1068 [ "$auto_channel" -gt 0 ] || freq="$(get_freq "$phy" "$channel" "$band")"
1069
1070 [ -n "$country" ] && {
1071 iw reg get | grep -q "^country $country:" || {
1072 iw reg set "$country"
1073 sleep 1
1074 }
1075 }
1076
1077 hostapd_conf_file="/var/run/hostapd-$phy.conf"
1078
1079 macidx=0
1080 staidx=0
1081
1082 [ -n "$chanbw" ] && {
1083 for file in /sys/kernel/debug/ieee80211/$phy/ath9k*/chanbw /sys/kernel/debug/ieee80211/$phy/ath5k/bwmode; do
1084 [ -f "$file" ] && echo "$chanbw" > "$file"
1085 done
1086 }
1087
1088 set_default rxantenna 0xffffffff
1089 set_default txantenna 0xffffffff
1090 set_default distance 0
1091
1092 [ "$txantenna" = "all" ] && txantenna=0xffffffff
1093 [ "$rxantenna" = "all" ] && rxantenna=0xffffffff
1094
1095 [ "$rxantenna" = "$prev_rxantenna" -a "$txantenna" = "$prev_txantenna" ] || mac80211_reset_config "$phy"
1096 wireless_set_data phy="$phy" txantenna="$txantenna" rxantenna="$rxantenna"
1097
1098 iw phy "$phy" set antenna $txantenna $rxantenna >/dev/null 2>&1
1099 iw phy "$phy" set distance "$distance" >/dev/null 2>&1
1100
1101 if [ -n "$txpower" ]; then
1102 iw phy "$phy" set txpower fixed "${txpower%%.*}00"
1103 else
1104 iw phy "$phy" set txpower auto
1105 fi
1106
1107 [ -n "$frag" ] && iw phy "$phy" set frag "${frag%%.*}"
1108 [ -n "$rts" ] && iw phy "$phy" set rts "${rts%%.*}"
1109
1110 has_ap=
1111 hostapd_ctrl=
1112 ap_ifname=
1113 hostapd_noscan=
1114 wpa_supp_init=
1115 for_each_interface "ap" mac80211_check_ap
1116
1117 [ -f "$hostapd_conf_file" ] && mv "$hostapd_conf_file" "$hostapd_conf_file.prev"
1118
1119 for_each_interface "sta adhoc mesh" mac80211_set_noscan
1120 [ -n "$has_ap" ] && mac80211_hostapd_setup_base "$phy"
1121
1122 local prev
1123 json_set_namespace wdev_uc prev
1124 json_init
1125 json_set_namespace "$prev"
1126
1127 wpa_supplicant_init_config
1128
1129 mac80211_prepare_iw_htmode
1130 active_ifnames=
1131 for_each_interface "ap sta adhoc mesh monitor" mac80211_prepare_vif
1132 for_each_interface "ap sta adhoc mesh monitor" mac80211_setup_vif
1133
1134 [ -x /usr/sbin/wpa_supplicant ] && wpa_supplicant_set_config "$phy"
1135 [ -x /usr/sbin/hostapd ] && hostapd_set_config "$phy"
1136
1137 [ -x /usr/sbin/wpa_supplicant ] && wpa_supplicant_start "$phy"
1138
1139 json_set_namespace wdev_uc prev
1140 wdev_tool "$phy" set_config "$(json_dump)" $active_ifnames
1141 json_set_namespace "$prev"
1142
1143 for_each_interface "ap sta adhoc mesh monitor" mac80211_set_vif_txpower
1144 wireless_set_up
1145 }
1146
1147 _list_phy_interfaces() {
1148 local phy="$1"
1149 if [ -d "/sys/class/ieee80211/${phy}/device/net" ]; then
1150 ls "/sys/class/ieee80211/${phy}/device/net" 2>/dev/null;
1151 else
1152 ls "/sys/class/ieee80211/${phy}/device" 2>/dev/null | grep net: | sed -e 's,net:,,g'
1153 fi
1154 }
1155
1156 list_phy_interfaces() {
1157 local phy="$1"
1158
1159 for dev in $(_list_phy_interfaces "$phy"); do
1160 readlink "/sys/class/net/${dev}/phy80211" | grep -q "/${phy}\$" || continue
1161 echo "$dev"
1162 done
1163 }
1164
1165 drv_mac80211_teardown() {
1166 json_select data
1167 json_get_vars phy
1168 json_select ..
1169 [ -n "$phy" ] || {
1170 echo "Bug: PHY is undefined for device '$1'"
1171 return 1
1172 }
1173
1174 mac80211_reset_config "$phy"
1175
1176 for wdev in $(list_phy_interfaces "$phy"); do
1177 ip link set dev "$wdev" down
1178 iw dev "$wdev" del
1179 done
1180 }
1181
1182 add_driver mac80211